unit uKOSfuncs;{  ,  _DOC\sysfuncr.txt}
interface
uses uKOSconst,{    , unit uKOSfuncs }
uKOStype;{ }


procedure TerminateProcess;{ -1 -   /}
procedure TerminateThread;{ -1 -   /}
procedure ThreadTerminate;{ -1 -   /}
{^^^^^^^^^^       ! ^^^^^^^^^^^^^^^^}
procedure CreateWindow(Left, Top, Width, Height : Integer;
Caption : PChar; BackColor, Style, CapStyle: cardinal);StdCall;{ 0 -    .}
Procedure DrawWindow(Left, Top, Right, Bottom: Integer;
Caption: PChar; BackColor, Style, CapStyle: Dword);StdCall; { 0 -    .}
{^^^^^^^^^^        ! ^^^^^^^^^^^^^^^^}
procedure PutPixel(x,y,Color:Cardinal);StdCall;  { 1 -    .}
function GetKey: cardinal;{ 2 -    .}
function WaitEvent: cardinal;{ 10 -  .}
function CheckEvent: cardinal;{ 11 - ,   ,  .}
procedure Redraw(c:Cardinal); StdCall;{ 12 - /  .}
  procedure BeginDraw; { 12  1 -  .}
  Procedure EndDraw; { 12  2 -   .}
function GetButton: cardinal;{ 17 -    }
function GetScreenSize : SIZE;{ 61 -       .}
procedure KeyboardSF1(c:Cardinal); StdCall;    { 66 -   }{ 1 -     .}

implementation

procedure TerminateThread;{ -1 -   /}
Asm
        mov    eax, SF_TERMINATE_PROCESS { -1 -   /}
        int    64
end;
procedure TerminateProcess;{ -1 -   /}
Asm
        mov    eax, SF_TERMINATE_PROCESS { -1 -   /}
        int    64
end;
procedure ThreadTerminate;{ -1 -   /}
Asm
        mov    eax, SF_TERMINATE_PROCESS { -1 -   /}
        int    64
end;

Procedure DrawWindow(Left, Top, Right, Bottom: Integer;
Caption: PChar; BackColor, Style, CapStyle: Dword);
 { 0 -    .}
Asm
        push   ebx
        push   edi
        push   esi
        xor    eax, eax
        mov    ebx, Left
        shl    ebx, 16
        add    ebx, Right
        mov    ecx, Top
        shl    ecx, 16
        add    ecx, Bottom
        mov    edx, Style
        or     edx, BackColor
        mov    edi, Caption
        mov    esi, CapStyle
        int    64
        pop    esi
        pop    edi
        pop    ebx
End;

Procedure CreateWindow(Left, Top, Width, Height : Integer;
 Caption : PChar; BackColor, Style, CapStyle: cardinal);
 { 0 -    .}
Asm
        push   ebx
        push   edi
        push   esi
        xor    eax, eax
        mov    ebx, [Left]
        shl    ebx, 16
        add    ebx, [Width]
        mov    ecx, [Top]
        shl    ecx, 16
        add    ecx, [Height]
        mov    edx, [Style]
        or     edx, [BackColor]
        mov    edi, [Caption]
        mov    esi, [CapStyle]
        int    64
        pop    esi
        pop    edi
        pop    ebx
end;

procedure PutPixel(x,y,Color:Cardinal);    { 1 -    .}
asm
        push   eax
        push   ebx
        push   ecx
        push   edx
        mov    ebx, [x]
        mov    ecx, [y]
        mov    edx, [Color]
        mov    eax, SF_PUT_PIXEL { 1 -    .}
        int    64
        pop    edx
        pop    ecx
        pop    ebx
        pop    eax
end;

function GetKey: cardinal;{ 2 -    .}
Asm
        mov    eax, SF_GET_KEY { 2 -    .}
        int    64
end;



function WaitEvent: cardinal;{ 10 -  .}
Asm
        mov    eax, SF_WAIT_EVENT;{ 10 -  .}
        int    64
end;
function CheckEvent: cardinal;{ 11 - ,   ,  .}
Asm
        mov    eax, SF_CHECK_EVENT;
        int    64
end;

procedure Redraw(c:Cardinal); { 12 - /  .}
{c = 1 -  1   }
{c = 2 -  2   .}
Asm
        push   ebx
        mov    eax, SF_REDRAW { 12 - /  .}
        mov    ebx,[c]
        int    64
        pop    ebx
end;

  procedure BeginDraw; { 12  1   }
Asm
        push   ebx
        mov    eax, SF_REDRAW { 12 - /  .}
        mov    ebx, SSF_BEGIN_DRAW { 1   }
        int    64
        pop    ebx
End;

  Procedure EndDraw; { 12 -  2   .}
Asm
        push   ebx
        mov    eax, SF_REDRAW { 12 - /  .}
        mov    ebx, SSF_END_DRAW { 2   .}
        int    64
        pop    ebx
End;

function GetButton: cardinal;{ 17 -    }
Asm
        mov    eax, SF_GET_BUTTON { 17 -    }
        int    64
end;

function GetScreenSize : SIZE;{ 61 -       .}
Asm
        push   ebx
        mov    eax, SF_GET_GRAPHICAL_PARAMS;{ 61 -       .}
        mov    ebx, 1
        int    64
        pop    ebx
end;

procedure KeyboardSF1(c:Cardinal);    { 66 -   }{ 1 -     .}
//    * 0 =  (ASCII-)
//    * 1 = 
asm
        push   eax
        push   ebx
        push   ecx
        mov    ebx, SSF_SET_INPUT_MODE{ 1 -     .}
        mov    ecx, [c]
        mov    eax, SF_KEYBOARD { 66 -   }
        int    64
        pop    ecx
        pop    ebx
        pop    eax
end;


end.







