unit uMain;{  }
interface
uses uKOSfuncs,{  ,  _DOC\sysfuncr.txt}
uKOSconst,{     , unit uKOSfuncs;}
uKOStype,{ }
u0Coder;
Procedure Main;

implementation
const   sz_hello  = AnsiString('Hello, Delphi!');
(* -------------------------------------------------------- *)
Var
  Left, Top, Right, Bottom: Integer;
  Scr: SIZE;
  hBoxLib: Pointer;
  HScrollbarDraw  : Procedure(Scrollbar: PSCROLLBAR); StdCall;
  HScrollbarMouse : Procedure(Scrollbar: PSCROLLBAR); StdCall;
  Scrollbar1: SCROLLBAR;


Procedure On_Mouse;
Begin
  HScrollbarMouse(@Scrollbar1);;
End;

Procedure On_Redraw;
Begin
 BeginDraw;
 DrawWindow(Left, Top, Right, Bottom, sz_hello, COLOR_WHITE, WS_SKINNED_FIXED + WS_COORD_CLIENT + WS_CAPTION, CAPTION_MOVABLE);
 Scrollbar1.all_redraw := 1;
 HScrollbarDraw(@Scrollbar1);
 EndDraw;
End;

Procedure Main;{    }
Begin
  Scr := GetScreenSize;

  Right  := Scr.Width  Shr 2;
  Bottom := Scr.Height Shr 2;
  Left   := (Scr.Width  - Right)  Shr 1;
  Top    := (Scr.Height - Bottom) Shr 1;

  hBoxLib := LoadLibrary('/sys/lib/box_lib.obj');
  HScrollbarDraw  := GetProcAddress(hBoxLib, 'scrollbar_h_draw');
  HScrollbarMouse := GetProcAddress(hBoxLib, 'scrollbar_h_mouse');

  With Scrollbar1 Do Begin
    ar_offset  := 1;
    all_redraw := 1;
    size_x     := 200;
    btn_high   := 16;
    bckg_col   := COLOR_GREEN;
    frnt_col   := COLOR_GREEN Or COLOR_BLUE;
    line_col   := COLOR_BLUE;
    start_y    := 40;
    size_y     := 16;
    start_x    := 35;
    max_area   := 160;
    cur_area   := 40;
    mode       := 1;
  End;

  SetEventMask(EM_REDRAW + EM_KEY + EM_BUTTON + EM_MOUSE);

  While TRUE Do Begin
    Case WaitEvent() Of
    REDRAW_EVENT : On_Redraw;
    KEY_EVENT    : On_Key;
    BUTTON_EVENT : On_Button;
    MOUSE_EVENT  : On_Mouse;
    End;
  End;
End;
end.
